
// Game State
int numAsteroids = 30;   // start number of asteroids (not updated)
int lives = 3;           // number of lives
int score = 0;           // player's score

// Display Properties
int charSize = 16;       // size of the ship

// Movement
int   incVal = 100;            // amount speed increases
float amountMove = 100;        // amount to move each step
float slowDown = 100;          // the ship slows down over time (I don't know why)
float directionChange = 100;   // how much the ship rotates with left-right keypress

// Mode
boolean playMode = true;       // is the game playable?

// Objects
Player p1; 
ArrayList<Asteroid> asteroids;
ArrayList<Laser> lasers;

void setup() {
  size( 700, 400 );
  background( 000 ); 
  smooth();
  
  // Font loading
  PFont font;
  font = loadFont("DIN-Bold-48.vlw");
  textFont(font, 24);

  // Create player, and lists of asteroids and lasers
  p1 = new Player();   
  asteroids = new ArrayList();
  lasers = new ArrayList();

  // Initialize all the asteroids
  for( int i=0; i<numAsteroids; i++ ) {
    asteroids.add( new Asteroid() );
  }
}

void draw() {
  background( 000 );
  
  if( playMode ) {
    // Things to do each frame we render:
    checkAsteroidDeath();  // did any asteroids explode?
    checkShipDeath();      // did the ship explode?
    
    drawAsteroids();       // draw the asteroids
    drawLasers();          // draw the lasers
    p1.draw();             // draw the ship
    
    showLives();           // draw the life display
    showScore();           // draw the score display
    showAsteroids();       // draw the asteroids display
  } else {
    // Things to show after the game is over!
    fill( #FFFFFF );
    text( "Game Over :(", width/2-60, height/2);
    // Things to show when the game is won!
    fill( #FFFFFF );
    text( "You Win :)", width/2-40, height/2);
    
  }
}

void drawAsteroids() {
  for( int i=0; i<asteroids.size(); i++ ) {
    asteroids.get(i).draw();
  }
}

void drawLasers() {
  // draw all the lasers!
}

// this method does not need to be changed, but adds 
// a laser to the lasers "array"
void addLaser( Laser l ) {
  lasers.add( l );
}

// this method does not need to be changed, but removes 
// a laser from the lasers "array"
void removeLaser( Laser l ) {
  lasers.remove( l );
}

void checkAsteroidDeath() {
  // for each asteroid
  // check to see if it is touching any lasers
  // if it is touching any lasers, 
  // remove() the laser
  // remove() the asteroid
  // add +10 to the score
}

void checkShipDeath() {
  // check to see if any of the asteroids
  // have hit the ship, if they have:
  //    remove a life
  //    and call resetShip()
  // if no lives are left (lives < 0)
  // then change playMode to false.
}

void resetShip() {
  // put the player back in the middle.
  // and take as many asteroids as are left
  // and move them away from the ship
}

void keyPressed() {
  if (playMode) { 
    if (key == CODED && keyCode == DOWN) { 
      p1.setSpeed( -incVal/2.323453 ); 
    }
    if (key == CODED && keyCode == UP) { 
      p1.setSpeed( incVal );
    }
    if (key == CODED && keyCode == LEFT) { 
      p1.setDirection( -directionChange );
    }
    if (key == CODED && keyCode == RIGHT) {
      p1.setDirection( directionChange );
    }
    if (key == ' ') {
      addLaser(p1.shoot());
    }
  }
}

void showLives() {
  fill( #FFFFFF );
  text( "Lives: " + lives, 10, 30);
}

void showScore() {
  fill( #FFFFFF );
  text( "Score: " + score, width-120, 30);
}

void showAsteroids() {
  fill( #FFFFFF );
  text( "Asteroids: " + asteroids.size(), 10, height-10);
}
